<?php

namespace Teknisa\DF\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\FilterCriteria;


class AprovacaoLancamentos extends \Teknisa\DF\Controllers\TeknisaCrud
{
    const APROVACAO_LANCAMENTOS_ENTRADA = 'aprovacao_lancamentos_entrada';
    const APROVACAO_LANCAMENTOS_SAIDA = 'aprovacao_lancamentos_saida';
    
    protected $dataSourceName = 'aprovacao_lancamentos';
    protected $parameterBagColumns = array(
        'P_IDENTRSAIDOP',
        'P_IDSITUACAO',
        'P_IDSTATUS',
        'P_CDFILIAL',
        'P_CDEMPRESA',
        'P_IDORIGDESTNF',
        'P_NRINSJURNF',
        'P_CDSERIE',
        'P_CDSERIEENTR',
        'P_CDTIPOOPER',
        'P_IDAVISOS',
        'P_IDERROS',
        'P_CDFILIEMIT',
        'P_CDINSCESTA',
        'P_CDINSCMUNI',
        'CDOPERADOR',
        'P_TDTEMISSAO',
        'P_DTEMISSAOINI',
        'P_DTEMISSAOFIN',
        'P_DTENTRSAIDINI',
        'P_DTENTRSAIDFIN',
        'P_IDAPROVACAO'
    );

    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        $filterCriteria = $request->getFilterCriteria();
        $conditions = $filterCriteria->getConditions();
        $filter = array(); 
        
        $keyRemoveIdentrsaidop = null;

        foreach ($conditions as $key => $condition) {

            if ($condition['columnName'] === 'P_IDENTRSAIDOP') {

                $identrsaidop = $condition['value'];

                if($identrsaidop === 'E')
                    $this->dataSourceName = self::APROVACAO_LANCAMENTOS_ENTRADA;
                else
                    $this->dataSourceName = self::APROVACAO_LANCAMENTOS_SAIDA;
                
                $keyRemoveIdentrsaidop = $key;
            }
        }

        if (is_numeric($keyRemoveIdentrsaidop))
            array_splice($conditions, $keyRemoveIdentrsaidop, 1);
            
        $dtEmissao = array("columnName" => "P_TDTEMISSAO", "operator" => "=", "value" => "");    
        
        foreach ($conditions as $key => $condition) {
            
            if(($condition['columnName'] == 'P_DTEMISSAOINI' || $condition["columnName"] == "P_DTEMISSAOFIN") && $condition["value"] == 'TD') {
                $condition["value"] = '';
                $dtEmissao["value"] = 'TD';
            }
            if($identrsaidop === 'S' && $condition['columnName'] !== 'P_CDSERIEENTR'
                && $condition['columnName'] !== 'P_CDFILIAL') {
                array_push($filter, $condition);
            }
            if($identrsaidop === 'E' 
                && $condition['columnName'] !== 'P_CDINSCMUNI'
                && $condition['columnName'] !== 'P_CDINSCESTA'
                && $condition['columnName'] !== 'P_CDFILIAL'
                && $condition['columnName'] !== 'P_CDTIPOOPER') {
                array_push($filter, $condition);
            }
            
            if($condition["columnName"] == 'P_CDFILIAL') {
                if(is_array($condition["value"])) {
                    if(count($condition["value"]) != 0 ) {
                        $filialstr = '_';
                        foreach($condition["value"] as $filial) {
                                $filialstr .= $filial . '_';
                        }
                        $filialstr = substr($filialstr, 0, -1);
                        $condition["operator"] = "=";
                        $condition["value"] = $filialstr;
                        array_push($filter, $condition);
                    }
                    else {
                        $condition["value"] = 'TD';
                        $condition["operator"] = '=';
                        array_push($filter, $condition);
                    }
                }
                else {
                   $condition["value"] = 'TD';
                   array_push($filter, $condition);
                }
            }
            
            if($condition["columnName"] == 'P_CDTIPOOPER') {
                if(is_array($condition["value"])) {
                    if(count($condition["value"]) != 0 ) {
                        $tipooperstr = '_';
                        foreach($condition["value"] as $filial) {
                                $tipooperstr .= $filial . '_';
                        }
                        $tipooperstr = substr($tipooperstr, 0, -1);
                        $condition["operator"] = "=";
                        $condition["value"] = $tipooperstr;
                        array_push($filter, $condition);
                    }
                    else {
                        $condition["value"] = 'TD';
                        $condition["operator"] = '=';
                        array_push($filter, $condition);
                    }
                }
                else {
                   $condition["value"] = 'TD';
                   array_push($filter, $condition);
                }
            }

        }

        array_push($filter, $dtEmissao);

        $page = $filterCriteria->getPage();
        $pageSize = $filterCriteria->getPageSize();
        $result = $this->crudService->getFilteredDataSet($this->dataSourceName, $filter, $page, $pageSize);
        $response->addDataset($result);
    }
    
}