<?php

namespace Teknisa\DF\Factories;

use Doctrine\ORM\EntityManager;
use Teknisa\Libs\Util\DateUtil;
use Teknisa\Model\Fiscal\Entities\Encargonfe;
use Teknisa\Model\Fiscal\Entities\Encargo;

class Ger00300EncargoFactory {
    
    public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }
    
    public function getEncargo($cdencargo, $nrorg){
        $parans = array(
            'cdencargo' => $cdencargo,
            'nrorg' => $nrorg
        );
        $encargo = $this->entityManager->getRepository(Encargo::class)->findOneBy($parans);
        return $encargo;
    }

    public function getEncargonfe($cdencargonfe, $nrorg){
        $parans = array(
            'cdencargonfe' => $cdencargonfe,
            'nrorg' => $nrorg
        );
        $encargonfe = $this->entityManager->getRepository(Encargonfe::class)->findOneBy($parans);
        return $encargonfe;
    }
    
    public function insereEncargonfe($row, $nrorg){
        $encargonfe = new Encargonfe();
        $encargonfe->setCdencargonfe($row['CDENCARGONFE']);
        $encargonfe->setNmencargonfe($row['NMENCARGONFE']);
        $encargonfe->setNrorg($nrorg);
        $encargonfe->setNrorgultatu($nrorg);
        $encargonfe->setNrorginclusao($nrorg);
        $encargonfe->setDtinclusao(DateUtil::getDataAtual());

        return $encargonfe;
    }
    
    public function insereEncargo($row, $nrorg){
        $encargo = new Encargo();
        $encargo->setCdencargo($row['CDENCARGO']);
        $encargo->setNmencargo($row['NMENCARGO']);
        $encargo->setIdencargo($row['IDENCARGO']);
        $encargo->setDtultatuenca(DateUtil::getDataAtual());
        $encargo->setCdencargonfe($row['CDENCARGONFE']);
        $encargo->setNrorg($nrorg);
        $encargo->setNrorgultatu($nrorg);
        $encargo->setNrorginclusao($nrorg);
        $encargo->setDtinclusao(DateUtil::getDataAtual());

        return $encargo;
    }
    
    public function updateEncargo($row, $nrorg){
        $parans = array(
            'cdencargo' => $row['CDENCARGO'],
            'nrorg' => $nrorg
        );
        $encargo = $this->entityManager->getRepository(Encargo::class)->findOneBy($parans);
        $encargo->setNmencargo($row['NMENCARGO']);
        $encargo->setIdencargo($row['IDENCARGO']);
        $encargo->setCdencargonfe($row['CDENCARGONFE']);
        $encargo->setDtultatu(DateUtil::getDataAtual());
        $encargo->setDtultatuenca(DateUtil::getDataAtual());
        return $encargo;
    }
}